# $Id: ruby2html.rb,v 1.2 2005/08/22 08:39:59 aamine Exp $

require 'ripper'
require 'cgi'
require 'stringio'

class Ruby2HTML < Ripper::Filter
  def on_default(event, tok, f)
    f << CGI.escapeHTML(tok)
  end

  def on_kw(tok, f)
    f << %Q[<span class="resword">#{CGI.escapeHTML(tok)}</span>]
  end

  def on_comment(tok, f)
    f << %Q[<span class="comment">#{CGI.escapeHTML(tok)}</span>]
  end

  def on_tstring_beg(tok, f)
    f << %Q[<span class="string">#{CGI.escapeHTML(tok)}]
  end

  def on_tstring_end(tok, f)
    f << %Q[#{CGI.escapeHTML(tok)}</span>]
  end
end

def main
  ARGV.each do |path|
    procfile path
  end
end

def procfile(path)
  buf = StringIO.new
  File.open(path) {|f|
    Ruby2HTML.new(f).parse(buf)
  }
  printf(<<-End)
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html lang="ja-JP">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=euc-jp">
  <meta http-equiv="Content-Language" content="ja-JP">
  <link rel="stylesheet" type="text/css" href="ruby.css">
  <title>#{File.basename(path)}</title>
</head>
<body>
<pre>
  End
  buf.string.each_with_index do |line, idx|
    printf '%4d  %s', idx+1, line
  end
  print(<<-End)
</pre>
</body>
</html>
  End
end

if $0 == __FILE__
  main
end
